Create item fee - Fabric

Create item fee

cURL

curl --request POST \
  --url https://api.fabric.inc/v3/carts/{cartId}/items/{itemId}/fees \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "name": "Eco Fee",
  "price": {
    "amount": 12.99
  },
  "taxable": true,
  "attributes": {
    "source": "eco"
  }
}
'

Python Request

import requests

url = "https://api.fabric.inc/v3/carts/{cartId}/items/{itemId}/fees"

payload = {
    "name": "Eco Fee",
    "price": { "amount": 12.99 },
    "taxable": True,
    "attributes": { "source": "eco" }
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)

JavaScript Fetch

const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    name: 'Eco Fee',
    price: {amount: 12.99},
    taxable: true,
    attributes: {source: 'eco'}
  })
};

fetch('https://api.fabric.inc/v3/carts/{cartId}/items/{itemId}/fees', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP cURL

<?php

$curl = curl_init();
curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/carts/{cartId}/items/{itemId}/fees",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "POST",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => 'Eco Fee',
    'price' => [
        'amount' => 12.99
    ],
    'taxable' => true,
    'attributes' => [
        'source' => 'eco'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-fabric-tenant-id: <x-fabric-tenant-id>"
  ],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Go Request

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/carts/{cartId}/items/{itemId}/fees"

payload := strings.NewReader("{\n  \"name\": \"Eco Fee\",\n  \"price\": {\n    \"amount\": 12.99\n  },\n  \"taxable\": true,\n  \"attributes\": {\n    \"source\": \"eco\"\n  }\n}")

req, _ := http.NewRequest("POST", url, payload)

req.Header.Add("x-fabric-tenant-id", "<x-fabric-tenant-id>")
    req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response Example

Successful Response

{
  "id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
  "name": "Eco Fee",
  "price": {
    "amount": 12.99
  },
  "taxable": true,
  "attributes": {
    "source": "eco"
  },
  "tax": {
    "total": 3,
    "collection": [
      {
        "amount": 3,
        "attributes": {
          "rate": "5.0",
          "type": "COUNTY"
        }
      }
    ]
  },
  "updatedAt": "2024-06-13T16:50:00.682Z",
  "createdAt": "2024-06-13T16:50:00.682Z",
  "taxDetails": {
    "destinationAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8",
    "originAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8"
  }
}

Error Responses

400 Bad Request

{
  "type": "BAD_REQUEST",
  "message": "x-fabric-tenant-id is required"
}

404 Not Found

{
  "type": "CART_NOT_FOUND",
  "message": "Cart not found"
}